/*:ja

@plugindesc 戦闘ウィンドウの変更

@author Saimon

@help
僕好みの戦闘ウィンドウにアレンジ

改造関数（プラグインの競合注意）:
Window_BattleStatus.prototype.initialize
Window_BattleStatus.prototype.spacing
Window_BattleStatus.prototype.itemHeight
Window_BattleStatus.prototype.numVisibleRows
Window_BattleStatus.prototype.maxCols
Window_BattleStatus.prototype.drawItem
Window_BattleStatus.prototype.basicAreaRect
Window_BattleStatus.prototype.gaugeAreaRect
Window_BattleStatus.prototype.drawBasicArea
Window_BattleStatus.prototype.drawGaugeAreaWithTp
Window_BattleActor.prototype.initialize


* @requiredAssets img/pictures/p_1
* @requiredAssets img/pictures/p_2
* @requiredAssets img/pictures/p_3
* @requiredAssets img/pictures/p_4
* @requiredAssets img/pictures/p_5
* @requiredAssets img/pictures/p_6
* @requiredAssets img/pictures/p_7
* @requiredAssets img/pictures/p_8
* @requiredAssets img/pictures/p_9
* @requiredAssets img/pictures/p_10
* @requiredAssets img/pictures/p_11
* @requiredAssets img/pictures/p_12
* @requiredAssets img/pictures/p_13
* @requiredAssets img/pictures/p_14
* @requiredAssets img/pictures/pyar
*/

(function() {
    //読み込ます
    ImageManager.loadPicture("p_1");
    ImageManager.loadPicture("p_2");
    ImageManager.loadPicture("p_3");
    ImageManager.loadPicture("p_4");
    ImageManager.loadPicture("p_5");
    ImageManager.loadPicture("p_6");
    ImageManager.loadPicture("p_7");
    ImageManager.loadPicture("p_8");
    ImageManager.loadPicture("p_9");
    ImageManager.loadPicture("p_10");
    ImageManager.loadPicture("p_11");
    ImageManager.loadPicture("p_12");
    ImageManager.loadPicture("p_13");
    ImageManager.loadPicture("p_14");
    ImageManager.loadPicture("pyar");
    
    //タイトルコマンド位置変える
    Window_TitleCommand.prototype.updatePlacement = function() {
        this.x = 50;
        this.y = 80;
    };
    
    //メニューにプラント立ち絵表示
    Window_MenuStatus.prototype.drawItemImage = function(index) {
        var actor = $gameParty.members()[index];
        var rect = this.itemRect(index);
        this.changePaintOpacity(actor.isBattleMember());
        var hp = actor.hp;
        var mhp = actor.mhp;
        if(hp < mhp / 100 * 25){
            var bitmap = ImageManager.loadPicture("p_3");
        }else if(hp < mhp / 2){
            var bitmap = ImageManager.loadPicture("p_2");
        }else{
            var bitmap = ImageManager.loadPicture("p_1");
        }
        this.contents.blt(bitmap, 0, 0,  bitmap.width, bitmap.height, 0, 0);
        //this.drawActorFace(actor, rect.x + 1, rect.y + 1, Window_Base._faceWidth, Window_Base._faceHeight);
        this.changePaintOpacity(true);
    };
    
    //アクターの情報変える
    Window_Base.prototype.drawActorSimpleStatus = function(actor, x, y, width) {
        y += 60;
        var lineHeight = this.lineHeight() + 10;
        var x2 = x + 160;
        var width2 = Math.min(200, width - 180 - this.textPadding());
        this.drawActorName(actor, x2, y - lineHeight);
        //this.drawActorLevel(actor, x, y + lineHeight * 1);
        this.drawActorIcons(actor, x, y + lineHeight * 2);
        this.drawActorClass(actor, x2, y);
        this.drawActorHp(actor, x2, y + lineHeight * 1, width2);
        this.drawActorMp(actor, x2, y + lineHeight * 2, width2);
        this.drawActorTp(actor, x2, y + lineHeight * 3, width2);
    };
    
    //Gばいばい
    Scene_Menu.prototype.create = function() {
        Scene_MenuBase.prototype.create.call(this);
        this.createCommandWindow();
        //this.createGoldWindow();
        this.createStatusWindow();
    };
    
    //順番変える
    Window_MenuCommand.prototype.makeCommandList = function() {
        this.addSaveCommand();
        this.addMainCommands();
        this.addFormationCommand();
        this.addOriginalCommands();
        this.addOptionsCommand();
        //this.addSaveCommand();
        this.addGameEndCommand();
    };
    
    //パラメーターを受け取る
    var parameters = PluginManager.parameters('SaimonBattle');//受けとるためのまじない？
    var saimonFace = String(parameters['SaimonFace']);
    
    //ウィンドウ初期化
    Window_BattleStatus.prototype.initialize = function() {
    var width = this.windowWidth();
    var height = 179;
    var x = Graphics.boxWidth - width;
    var y = Graphics.boxHeight - height;
    Window_Selectable.prototype.initialize.call(this, x , y , width, height + 10);
    this.opacity = 0;
    this.refresh();
    this.openness = 0;
};
    
    //選択ウィンドウの長さ
    Window_BattleStatus.prototype.spacing = function() {
    return 4;
};
    
    //選択ウィンドウの高さ
    Window_BattleStatus.prototype.itemHeight = function() {
    return 153 ;
};
    
    
    //選択肢の横の数
    Window_BattleStatus.prototype.numVisibleRows = function() {
    return 1;
};
    
    //選択肢の段の数
    Window_BattleStatus.prototype.maxCols = function() {
    return 4;
};

    //いろいろ表示
    Window_BattleStatus.prototype.drawItem = function(index) {
    var actor = $gameParty.battleMembers()[index];
        
    this.drawFaseArea(this.faseAreaRect(index), actor);//顔グラ表示
    this.drawBasicArea(this.basicAreaRect(index), actor);
    this.drawGaugeArea(this.gaugeAreaRect(index), actor);
};
    
    //顔グラとか描写　自作関数
    Window_BattleStatus.prototype.drawFaseArea = function(rect, actor) {
    this.drawActorFace(actor,rect.x - 6,0,144, 144);//顔グラ描写
};
    
    //顔グラとか位置 自作関数
    Window_BattleStatus.prototype.faseAreaRect = function(index) {
    var rect = this.itemRectForText(index);
    return rect;
};
    
    //名前とか位置
    Window_BattleStatus.prototype.basicAreaRect = function(index) {
    var rect = this.itemRectForText(index);
    rect.width -= this.gaugeAreaWidth();
    return rect;
};
    
    //HP用ゲージ描写　改造関数
    Window_Base.prototype.SaimondrawGauge1 = function(x, y, width, rate, color1, color2) {
    var fillW = Math.floor(width * rate);
    var gaugeY = y + this.lineHeight() - 13;
    this.contents.fillRect(x, gaugeY, width, 11, this.gaugeBackColor());//ゲージ大きさ変更
    this.contents.gradientFillRect(x, gaugeY, fillW, 11, color1, color2);//ゲージ大きさ変更
};
    
    //MP用ゲージ描写
    Window_Base.prototype.SaimondrawGauge2 = function(x, y, width, rate, color1, color2) {
    var fillW = Math.floor(width * rate);
    var gaugeY = y + this.lineHeight() - 13;
    this.contents.fillRect(x, gaugeY, width, 11, this.gaugeBackColor());//ゲージ大きさ変更
    this.contents.gradientFillRect(x, gaugeY, fillW, 11, color1, color2);//ゲージ大きさ変更
};
    
    //TP用ゲージ描写
    Window_Base.prototype.SaimondrawGauge3 = function(x, y, width, rate, color1, color2) {
    var fillW = Math.floor(width * rate);
    var gaugeY = y + this.lineHeight() - 13;
    this.contents.fillRect(x, gaugeY, width, 11, this.gaugeBackColor());//ゲージ大きさ変更
    this.contents.gradientFillRect(x, gaugeY, fillW, 11, color1, color2);//ゲージ大きさ変更
};

    //HPゲージとか位置
    Window_BattleStatus.prototype.gaugeAreaRect = function(index) {
    var rect = this.itemRectForText(index);
    rect.x -= 6;
    return rect;
};
    
    //名前とか描写
    Window_BattleStatus.prototype.drawBasicArea = function(rect, actor) {
    this.drawActorIcons(actor, rect.x, 10, 140);//状態異常
    this.drawActorName(actor, rect.x + 145 , -5 , 100);//名前
    };
    
    //HPとか描写
    Window_BattleStatus.prototype.drawGaugeAreaWithTp = function(rect, actor) {
    this.saimondrawActorTp(actor, rect.x + 160, 90, 400);//TP描写
    this.saimondrawActorMp(actor, rect.x + 160, 50, 400);//MP描写
    this.saimondrawActorHp(actor, rect.x + 160, 10, 400);//HP描写
};
    
    //HP描写内容　改造関数
    Window_Base.prototype.saimondrawActorHp = function(actor, x, y, width) {
    width = width || 186;
    var color1 = this.hpGaugeColor1();
    var color2 = this.hpGaugeColor2();
    this.SaimondrawGauge1(x, y + 10, width, actor.hpRate(), color1, color2);//改造関数
    this.changeTextColor(this.systemColor());
    this.contents.fontSize = 26;//フォント変える
    this.drawText(TextManager.hpA, x, y + 12, 44);
    this.contents.fontSize = 30;//フォント変える
    this.SaimondrawCurrentAndMax(actor.hp, actor.mhp, x , y, width,
                           this.hpColor(actor), this.normalColor());//HP描写呼出し
    this.contents.fontSize = this.standardFontSize();//元々のフォント
};
    
    
    //MP描写内容　改造関数
    Window_Base.prototype.saimondrawActorMp = function(actor, x, y, width) {
    width = width || 186;
    var color1 = this.mpGaugeColor1();
    var color2 = this.mpGaugeColor2();
    this.SaimondrawGauge2(x, y + 10, width, actor.mpRate(), color1, color2);
    this.changeTextColor(this.systemColor());
    this.contents.fontSize = 26;//フォント変える
    this.drawText(TextManager.mpA, x, y + 12, 44);
    this.contents.fontSize = 30;//フォント変える
    this.SaimondrawCurrentAndMax(actor.mp, actor.mmp, x, y, width,
                           this.mpColor(actor), this.normalColor());
    this.contents.fontSize = this.standardFontSize();//元々のフォント
};
    
    //HP・MP数値描写内容　改造関数
    Window_Base.prototype.SaimondrawCurrentAndMax = function(current, max, x, y,
                                                   width, color1, color2) {
    var labelWidth = this.textWidth('HP');
    var valueWidth = this.textWidth('0000');
    var slashWidth = this.textWidth('/');
    var x1 = x + width - valueWidth;
    var x2 = x1 - slashWidth;
    var x3 = x2 - valueWidth;
    y += 5;//位置ずらす
    this.changeTextColor(color1);
    this.drawText(current, x3, y, valueWidth, 'right');
    this.changeTextColor(color2);
    this.drawText('/', x2, y, slashWidth, 'right');
    this.drawText(max, x1, y, valueWidth, 'right');
};
    

    //TP描写内容　改造関数
    Window_Base.prototype.saimondrawActorTp = function(actor, x, y, width) {
    width = width || 186;
    var color1 = this.tpGaugeColor1();
    var color2 = this.tpGaugeColor2();
    this.SaimondrawGauge3(x, y + 10, width, actor.tpRate(), color1, color2);
    this.changeTextColor(this.systemColor());
    this.contents.fontSize = 26;//フォント変える
    this.drawText(TextManager.tpA, x, y + 12, 44);
    this.changeTextColor(this.tpColor(actor));
    this.contents.fontSize = 30;//フォント変える
    this.drawText(actor.tp, x + width - 64, y + 10, 64, 'right');
    this.contents.fontSize = this.standardFontSize();//元々のフォント
};
    
    
    //味方選択に出るウィンドウ位置
    Window_BattleActor.prototype.initialize = function(x, y) {
    Window_BattleStatus.prototype.initialize.call(this);
    this.x = x + 192;
    this.y = y;
    this.openness = 255;
    this.hide();
};

        

})();